#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Aug 16 17:35:41 2021

@author: ad
"""
import sqlite3
from flask import Flask, render_template, request

app = Flask(__name__)

@app.route('/')
def index():
    return render_template("index.html")

################################
# Q2 Une nouvelle route '/test #
################################

    
@app.route('/reservation')
def reservation():
    return render_template('reservation.html', message='')

@app.route('/resa_enregistree', methods=["POST"])
def resa_enregistree():
    
    #on récupère les données envoyées dans le formulaire
    result = request.form 
    nom = result['nom']
    prenom = result['prenom']
    immatriculation = result['vehicule']
    debut = result['debut']
    fin = result['fin']
    
    # si le formulaire a été correctement complété
    if nom != '' and prenom != '' and debut !='' and fin != '' and fin > debut: 
        # Recherche de l'id du client dont on connait le nom et le prenom
        conn = sqlite3.connect('bdd/rento.db') # connection à la BDD
        cur = conn.cursor()
        
        #########################################################################
        # Q3 la requête pour connaître l'id du client connaissant nom et prenom #
        #########################################################################
        cur.execute("",(nom,prenom))
        
        conn.commit()
        ide = cur.fetchall()  #on récupère le résultat de la requête sous la forme d'un tuple
        cur.close()
        conn.close()
        
        if ide == [] : #il n'y a pas de client enregistré avec ces nom et prenom
            #revenir à la page réservation
            return render_template('reservation.html', message="Ce client n'est pas encoreenregistré")
        
        else : #le client existe dans la base
            conn = sqlite3.connect('bdd/rento.db') # connection à la BDD
            cur = conn.cursor()
            # On cherche le nombre de réservations incompatibles avec la demande déjà dans la base
            cur.execute("SELECT COUNT(*) from reservations WHERE immatriculation = ? \
                        AND ( ( date_fin >= ? AND date_debut <= ?) OR ( date_fin >= ? AND date_debut <= ?) OR ( date_debut >= ? AND date_fin <= ?))",\
                        (immatriculation, debut, debut, fin, fin, debut, fin))
            conn.commit()
            
            resapossible = cur.fetchall()==[(0,)] #resapossible vaut True s'il n'y a pas de résa incompatible déjà enregistrée
            cur.close()
            conn.close()
            
            if resapossible : #La reservation est possible
                ide = int(ide[0][0]) #id su client 
                conn = sqlite3.connect('bdd/rento.db') # connection à la BDD
                cur = conn.cursor() 
                
                ############################################################
                # Q4 la requête pour insérer la réservation dans la base   #
                ############################################################
                cur.execute("",(immatriculation, ide, debut, fin))
                
                conn.commit()
                cur.close()
                conn.close()
                
                return render_template('reservationOK.html',immatriculation=immatriculation, nom=nom, prenom=prenom, debut=debut, fin=fin)
            
            else : #resapossible vaut False, la reservation n'est pas possible
                return render_template('reservation.html',message='pas de disponibilité') #revenir à la page de reservation
        
    
    else :
        #revenir à la page réservation
        return render_template('reservation.html', message='formulaire non valide')


@app.route('/disponibilite')
def disponibilite():
    return render_template('disponibilite.html')

@app.route('/resultat_dispo',methods=["POST"])
def resultat_dispo():
    #on récupère les données envoyées dans le formulaire
    result=request.form
    
    debut = result['debut']
    fin = result['fin']
    
    conn = sqlite3.connect('bdd/rento.db') # connection à la BDD
    cur = conn.cursor()
    
    ##########################################################################
    # Q5 : La requete pour connaitre les véhicules déjà reservés à ces dates #
    #  Vous pouvez vous aider de la reqête écrite aux environs de la ligne 65#
    ##########################################################################
    
    cur.execute()
    
    conn.commit()
    resapossible = cur.fetchall() #on récupère le résultat de la requête sous la forme d'un tuple
    cur.close()
    conn.close()
    
    #les véhicules disponibles à ces dates sont ceux qui ne sont pas dans le résultat de la requête
    liste_vehicules = [('123OC17',), ('92NOV10',), ('155DEC99',), ('934MAR21',), ('999JUN06',), ('100NOV09',), ('34DEC21',)]
    dico = {'123OC17':'RENAULT Clio', '92NOV10':'PEUGEOT 206', '155DEC99':'FIAT Panda', '934MAR21':'VOLVO XC40', '999JUN06':'RENAULT Scenic', '100NOV09':'PEUGEOT 308', '34DEC21':'PEUGEOT 5008' }
    vehicules_dispos = [dico[element[0]] for element in liste_vehicules if element not in resapossible]
   
    return render_template('resultat_dispo.html', vehicules_dispos=vehicules_dispos, debut=debut, fin=fin)

@app.route('/ajouter_client')
def ajouter_client():
    return render_template('ajouter_client.html')
    
#############################################################
# Q6 : la fonction permettant d'ajouter un client à la base #
#############################################################
@app.route('/client_ajoute',methods=["POST"])
def client_ajoute():
    pass


 
#Pour lancer le serveur Flask
app.run(debug=True)

